# Uses of Interface
net.shibboleth.idp.attribute.filter.Matcher

Packages that use Matcher
Package
Description
net.shibboleth.idp.attribute.filter
This package contains a filtering engine for a collection of `IdPAttribute`s.
net.shibboleth.idp.attribute.filter.matcher.impl
Implementation of the various policy matchers.
net.shibboleth.idp.attribute.filter.matcher.logic.impl
Implementation of the logical attribute matchers.
net.shibboleth.idp.attribute.filter.matcher.saml.impl
This is where the attribute matchers that understand SAML live.
net.shibboleth.idp.attribute.filter.testing
Testing utility classes.

## Uses of Matcher in net.shibboleth.idp.attribute.filter

Classes in net.shibboleth.idp.attribute.filter that implement Matcher
Modifier and Type
Class
Description
`final class`
`MatcherFromPolicy`
Bridging class to go from a `PolicyRequirementRule` to a `Matcher`.
Fields in net.shibboleth.idp.attribute.filter declared as Matcher
Modifier and Type
Field
Description
`private Matcher`
AttributeRule.`matcher`
Filter that permits the release of attribute values.
`private final Matcher`
PolicyFromMatcher.`matcher`
The rule we are shadowing.
`static final Matcher`
Matcher.`MATCHER_FAILS`
A `Matcher` that fails.
`static final Matcher`
Matcher.`MATCHES_ALL`
A `Matcher` that returns true/all attribute values as matched.
`static final Matcher`
Matcher.`MATCHES_NONE`
A `Matcher` that returns false/no attribute values as matched.
`private final Matcher`
PolicyFromMatcherId.`theMatcher`
The rule we are shadowing.
Methods in net.shibboleth.idp.attribute.filter that return Matcher
Modifier and Type
Method
Description
`Matcher`
AttributeRule.`getMatcher()`
Gets the matcher used to determine the attribute values filtered by this rule.
`Matcher`
PolicyFromMatcher.`getMatcher()`
Testing support.
`Matcher`
PolicyFromMatcherId.`getMatcher()`
Testing support.
Methods in net.shibboleth.idp.attribute.filter with parameters of type Matcher
Modifier and Type
Method
Description
`void`
AttributeRule.`setMatcher(Matcher theMatcher)`
Sets the rule used to determine permitted attribute values filtered by this rule.
Constructors in net.shibboleth.idp.attribute.filter with parameters of type Matcher
Modifier
Constructor
Description
``
`PolicyFromMatcher(Matcher theMatcher)`
Constructor.
``
`PolicyFromMatcherId(Matcher matcher, String attribute)`
Constructor.

## Uses of Matcher in net.shibboleth.idp.attribute.filter.matcher.impl

Classes in net.shibboleth.idp.attribute.filter.matcher.impl that implement Matcher
Modifier and Type
Class
Description
`class`
`AbstractMatcher`
This is the base of all implementations of `Matcher` which do some sort of comparison.
`class`
`AbstractRegexpStringMatcher`
General `Matcher` for regexp comparison of strings in Attribute Filters.
`class`
`AbstractStringMatcher`
General `Matcher` for `String` comparison of strings in Attribute Filters.
`class`
`AttributeScopeRegexpMatcher`
Test that the scope in a `ScopedStringAttributeValue` is a regexp match to configured value.
`class`
`AttributeScopeStringMatcher`
Test that the scope of a `ScopedStringAttributeValue` is a string match to the value configured.
`class`
`AttributeValueRegexpMatcher`
Test that an `IdPAttributeValue` is a regexp match to the configured string.
`class`
`AttributeValueStringMatcher`
Test that an `IdPAttributeValue` is a string match to the configured string.
`class`
`ScriptedMatcher`
A `Matcher` that delegates to a JSR-223 script for its actual processing.

## Uses of Matcher in net.shibboleth.idp.attribute.filter.matcher.logic.impl

Classes in net.shibboleth.idp.attribute.filter.matcher.logic.impl that implement Matcher
Modifier and Type
Class
Description
`class`
`AbstractComposedMatcher`
Base class for `Matcher` implementations that are compositions of two or more other `Matcher`s.
`class`
`AndMatcher`
`Matcher` that implements the conjunction of matchers.
`final class`
`NotMatcher`
`Matcher` that implements the negation of a matcher.
`class`
`OrMatcher`
`Matcher` that implements the disjunction of matchers.
Fields in net.shibboleth.idp.attribute.filter.matcher.logic.impl declared as Matcher
Modifier and Type
Field
Description
`private Matcher`
NotMatcher.`negatedMatcher`
The matcher we are negating.
Fields in net.shibboleth.idp.attribute.filter.matcher.logic.impl with type parameters of type Matcher
Modifier and Type
Field
Description
`private List<Matcher>`
AbstractComposedMatcher.`matchers`
The composed matchers.
Methods in net.shibboleth.idp.attribute.filter.matcher.logic.impl that return Matcher
Modifier and Type
Method
Description
`Matcher`
NotMatcher.`getNegatedMatcher()`
Get the matcher that is being negated.
Methods in net.shibboleth.idp.attribute.filter.matcher.logic.impl that return types with arguments of type Matcher
Modifier and Type
Method
Description
`List<Matcher>`
AbstractComposedMatcher.`getComposedMatchers()`
Get the composed matchers.
Methods in net.shibboleth.idp.attribute.filter.matcher.logic.impl with parameters of type Matcher
Modifier and Type
Method
Description
`void`
NotMatcher.`setNegation(Matcher valueMatcher)`
Constructor.
Method parameters in net.shibboleth.idp.attribute.filter.matcher.logic.impl with type arguments of type Matcher
Modifier and Type
Method
Description
`void`
AbstractComposedMatcher.`setSubsidiaries(List<Matcher> composedMatchers)`
Set the matchers to be composed.

## Uses of Matcher in net.shibboleth.idp.attribute.filter.matcher.saml.impl

Classes in net.shibboleth.idp.attribute.filter.matcher.saml.impl that implement Matcher
Modifier and Type
Class
Description
`class`
`AbstractMatchesShibMDScopeMatcher`
Base class for filters which rely on the issuer's <shibmd:scope> extensions.
`class`
`AttributeInMetadataMatcher`
Matcher that checks whether an attribute is enumerated in an SP's metadata as a required or optional attribute.
`class`
`AttributeScopeMatchesShibMDScope`
Class to implement a filter of scopes against <shibmd:scope>.
`class`
`AttributeValueMatchesShibMDScope`
Class to implement a filter of string values against <shibmd:scope>.

## Uses of Matcher in net.shibboleth.idp.attribute.filter.testing

Classes in net.shibboleth.idp.attribute.filter.testing that implement Matcher
Modifier and Type
Class
Description
`class`
`MockMatcher`
A simple, mock implementation of `Matcher`.